% This function can be used only in super-resolved some KFs
function BOBMC_dynaSR(path1, path2, path3)

addpath('.\motion\');
mkdir(path3);
dirx=dir([path2 '*.jpg']);
dirx2=dir([path1 '*.jpg']);
len1=length(dirx2);
gop=4;  % GOP size
mbSize = 4; % block size
warning('off','all');
myct = 1;
len1 = 57;  % # of frames
for i=1+gop:gop:len1
    oriimg=imresize(imread([path1 dirx2(i-gop).name]),3);
    oriimg =double(rgb2gray(oriimg));
    [row, col] = size(oriimg);
    nextimg=imresize(imread([path1 dirx2(i).name]),3); 
    nextimg=double(rgb2gray(nextimg));
    %  Read the KFs
    KF1 = imread([path2 dirx(myct).name]);
    KF2 = imread([path2 dirx(myct+1).name]);
    imwrite(KF1, [path3 dirx2(i-gop).name]);
    imwrite(KF2, [path3 dirx2(i).name]);
    for j=i-gop+1:i-1
        % Forword MC
        currentImg=imresize(imread([path1 dirx2(j).name]),3);
        currentImgG =double(rgb2gray(currentImg));
        [mvF,cmps, costF]=motionEstSESTSS(currentImgG, oriimg, mbSize, 8);
        % Backword MC
        [mvB,cmps, costB]=motionEstSESTSS(currentImgG, nextimg, mbSize, 8);
        % Motion compensation
        ct = 1;
        for k = 1 : mbSize : row-mbSize+1
            for m = 1 : mbSize : col-mbSize+1
               
                if (costF(ct) < costB(ct))
                    mx = mvF(1,ct)+k;  my = mvF(2,ct)+m;
                    MCF = KF1(mx:mx+mbSize-1, my:my+mbSize-1,:);
                    currentImg(k:k+mbSize-1, m:m+mbSize-1, :) = MCF;
                else
                    mx = mvB(1,ct)+k;  my = mvB(2,ct)+m;
                    MCB = KF2(mx:mx+mbSize-1, my:my+mbSize-1,:);
                    currentImg(k:k+mbSize-1, m:m+mbSize-1, :) = MCB;
                end
                ct = ct + 1;
            end
        end
        % End to MC
        imwrite(currentImg, [path3 dirx2(j).name]);
        disp(['Finish ' num2str(j) '-th frame compensation...']);
    end
    myct = myct + 1;
end
