function [x0,YmeanH,Ahat,Bhat,Chat] = dytex_pair(Y, YH, YYY, n, nv, method, YHMEAN)
% Y: LR video sequence, YH: HR video sequences
% n: the dimension of SVD to be reduced
% nv: the dimension of transition matrix to be reduced
% Suboptimal Learning of Dynamic Textures;
% (c) UCLA, March 2001.
tau = size(Y,2); Ymean = mean(Y,2);
YY = Y-Ymean*ones(1,tau);
tau = size(YH,2); YmeanH = mean(YH,2);
YYH = YH-YmeanH*ones(1,tau);
if (~isempty(YYY))
    tau = size(YYY,2); YmeanHH = mean(YYY,2);
    YYYH = YYY-YmeanHH*ones(1,tau);
end
if (~isempty(YHMEAN))
    YmeanH = YHMEAN;
end
% YmeanH = YH(:,1);

% use SVD as the basis function
[U,S,V] = svd(YY,0);
[UH,SH,VH] = svd(YYH,0);
if (~isempty(YYY))
    [UHH,SHH,VHH] = svd(YYYH,0);
end
if (n>size(UH,2)), n = size(UH,2); end

% Get the first n principle components with largest egenvalues.
Chat = U(1:size(Y,1), 1:n);
CHhat = UH(1:size(YH,1), 1:n);
if (~isempty(YYY))
    CHHhat = UHH(1:size(YYH,1), 1:n);
end

Xhat = S(1:n,1:n)*V(:,1:n)';
XHhat = SH(1:n,1:n)*VH(:,1:n)';
if (~isempty(YYY))
    XHHhat = SHH(1:n,1:n)*VHH(:,1:n)';
end
x0=Xhat(:,1);

Ahat = Xhat(:,2:tau)*pinv(Xhat(:,1:(tau-1)));
if (~isempty(YYY))
    AHHhat = XHHhat(:,2:tau)*pinv(XHHhat(:,1:(tau-1)));
end
AHhat = XHhat(:,2:tau)*pinv(XHhat(:,1:(tau-1)));

% Dynamic
% [Projection, egx] = eigs(cov(Ahat'),3);
% A1 = Projection' * (Ahat');
% A2 = Projection' * (AHhat');
% A3 = Projection' * (AHHhat');
% 
% a=1;

Vhat = Xhat(:,2:tau)-Ahat*Xhat(:,1:(tau-1));

VHhat = XHhat(:,2:tau)-AHhat*XHhat(:,1:(tau-1));
if (~isempty(YYY))
    VHHhat = XHHhat(:,2:tau)-AHHhat*XHHhat(:,1:(tau-1));
end
[Uv,Sv,~] = svd(Vhat,0);
[UvH,SvH,~] = svd(VHhat,0);
if (~isempty(YYY))
    [UvHH,SvHH,~] = svd(VHHhat,0);
end
Bhat = Uv(:,1:nv)*Sv(1:nv,1:nv)/sqrt(tau-1);
BHhat = UvH(:,1:nv)*SvH(1:nv,1:nv)/sqrt(tau-1);
if (~isempty(YYY))
    BHHhat = UvHH(:,1:nv)*SvHH(1:nv,1:nv)/sqrt(tau-1);
end
if method==1
    Ahat = AHHhat;
%     YmeanH = YmeanHH;
%     Chat = CHHhat;
%     Bhat = BHHhat;
end
if method==2
    Ahat = AHhat;
end


